## quassel 0.13.1

=== CMakeLists.txt ===
# Main CMake file for building Quassel IRC
#
# See INSTALL for possible CMake options (or read the code, Luke)
#####################################################################

# General setup
#####################################################################

# Versions
set(QUASSEL_MAJOR  0)
set(QUASSEL_MINOR 13)
set(QUASSEL_PATCH  1)
set(QUASSEL_VERSION_STRING "0.13.1")

# Build type
if (CMAKE_CONFIGURATION_TYPES)
    set(CMAKE_CONFIGURATION_TYPES Release RelWithDebInfo Debug Debugfull Profile)
    set(CMAKE_CONFIGURATION_TYPES "${CMAKE_CONFIGURATION_TYPES}" CACHE STRING "These are the configuration types we support" FORCE)
endif()

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the type of build, options are: Release RelWithDebInfo Debug Debugfull Profile None" FORCE)
endif()

# Output CMake and Quassel versions as well as build type for debug reasons
message(STATUS "Building Quassel ${QUASSEL_VERSION_STRING}...")
message(STATUS "Using CMake ${CMAKE_VERSION}")
message(STATUS "CMake build type: ${CMAKE_BUILD_TYPE}")

# Support ccache if found
# This should happen before calling project(), so compiler settings are validated.
option(USE_CCACHE "Enable support for ccache if available" ON)
if (USE_CCACHE)
    message(STATUS "Checking for ccache")
    find_program(CCACHE_PROGRAM ccache)
    if (CCACHE_PROGRAM)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_PROGRAM}")
        message(STATUS "Checking for ccache - enabled")
    else()
        message(STATUS "Checking for ccache - not found")
    endif()
endif()

# Set up project
project(Quassel C CXX)

# General conveniences
set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Include various CMake modules
include(CMakePushCheckState)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCXXSourceCompiles)
include(CMakeDependentOption)
include(FeatureSummary)

# Tell CMake about or own modules
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
include(QuasselCompileSettings)
include(QuasselMacros)


# Options and variables that can be set on the command line
#####################################################################

# Choose a Qt version. We support USE_QT5 and USE_QT4; if neither is set, Qt5 will be used
option(USE_QT5 "Enable support for Qt5" OFF)
if (USE_QT5) # takes precedence
    set(USE_QT4 OFF)
else()
    if (NOT USE_QT4)
        set(USE_QT5 ON)
    endif()
endif()

# Select the binaries to build
option(WANT_CORE     "Build the core (server) binary"           ON)
option(WANT_QTCLIENT "Build the client-only binary"             ON)
option(WANT_MONO     "Build the monolithic (all-in-one) binary" ON)
add_feature_info(WANT_CORE WANT_CORE "Build the core (server) binary")
add_feature_info(WANT_QTCLIENT WANT_QTCLIENT "Build the client-only binary (requires a core to connect to)")
add_feature_info(WANT_MONO WANT_MONO "Build the monolithic (all-in-one) binary")

# Whether to enable KDE integration (work in progress for Qt5 / KDE Frameworks)
# Note that when building with Qt5, WITH_KDE enables integration with higher-tier KDE frameworks that
# require runtime support. We still optionally make use of certain Tier 1 frameworks even if WITH_KDE
# is disabled.
if (USE_QT4)
    option(WITH_KDE "KDE4 integration" OFF)
    add_feature_info(WITH_KDE WITH_KDE "Enable KDE4 integration")
else()
    option(WITH_KDE "Integration with the KDE Frameworks runtime environment")
    add_feature_info(WITH_KDE WITH_KDE "Integrate with the KDE Frameworks runtime environment")
endif()

# Icon theme support. By default, install the Breeze icon theme (may be disabled if a system installation is present)
option(WITH_BUNDLED_ICONS "Install required icons from the Breeze icon theme" ON)
add_feature_info(WITH_BUNDLED_ICONS WITH_BUNDLED_ICONS "Install required icons from the Breeze icon theme")

# For Qt4, always support Oxygen
cmake_dependent_option(WITH_OXYGEN_ICONS "Support the Oxygen icon theme (KDE4)" OFF "USE_QT5" ON)
add_feature_info(WITH_OXYGEN_ICONS WITH_OXYGEN_ICONS "Support the Oxygen icon theme (KDE4)" OFF)

if (WITH_BUNDLED_ICONS)
    add_definitions(-DWITH_BUNDLED_ICONS)
endif()
if (WITH_OXYGEN_ICONS)
    add_definitions(-DWITH_OXYGEN_ICONS)
endif()

# For this, the feature info is added after we know if QtWebkit is installed
option(WITH_WEBKIT "WebKit support (for link previews) (legacy)" OFF)

# For this, the feature info is added after we know if QtWebEngine is installed
option(WITH_WEBENGINE "WebEngine support (for link previews)" ON)

if (APPLE)
    # Notification Center is only available in > 10.8, which is Darwin v12
    if (NOT CMAKE_SYSTEM_VERSION VERSION_LESS 12)
        option(WITH_NOTIFICATION_CENTER "OS X Notification Center support" ON)
        add_feature_info(WITH_NOTIFICATION_CENTER WITH_NOTIFICATION_CENTER "Use the OS X Notification Center")
    endif()
    find_library(CARBON_LIBRARY Carbon)
    mark_as_advanced(CARBON_LIBRARY)
    link_libraries(${CARBON_LIBRARY})
endif()

# Always embed on Windows, OSX or for a static build; never embed when enabling KDE integration
set(EMBED_DEFAULT OFF)
if (STATIC OR WIN32 OR APPLE)
    set(EMBED_DEFAULT ON)
endif()
cmake_dependent_option(EMBED_DATA "Embed icons and translations into the binaries instead of installing them" ${EMBED_DEFAULT}
                                   "NOT STATIC;NOT WIN32;NOT WITH_KDE" ${EMBED_DEFAULT})
if (NOT EMBED_DEFAULT)
    add_feature_info(EMBED_DATA EMBED_DATA "Embed icons and translations in the binaries instead of installing them")
endif()

# The following options are not for end-user consumption, so don't list them in the feature summary
cmake_dependent_option(DEPLOY "Add required libs to bundle resources and create a dmg. Note: requires Qt to be built with 10.4u SDK" OFF "APPLE" OFF)

# Static builds are not supported and require some manual setup! Don't enable unless you know what you're doing (we don't know either)
cmake_dependent_option(STATIC      "Enable static building (not supported)" OFF "NOT WITH_KDE" OFF)

# For static builds, arbitrary extra libs might need to be linked
# Define a comma-separated list here
# e.g. for pgsql, we need -DLINK_EXTRA=pq;crypt
set(LINK_EXTRA "" CACHE STRING "Semicolon-separated list of libraries to be linked")
if (LINK_EXTRA)
    string(REPLACE "," ";" LINK_EXTRA ${LINK_EXTRA})
    link_libraries(${LINK_EXTRA})
endif()


# List of authenticators and the cmake flags to build them
# (currently that's just LDAP, but more can be added here).
####################################################################
option(WITH_LDAP "Enable LDAP authentication support if present on system" ON)

# Setup CMake
#####################################################################

if (USE_QT5 AND WITH_KDE)
    cmake_minimum_required(VERSION 2.8.12)
else()
    cmake_minimum_required(VERSION 2.8.9)
endif()

# Setting COMPILE_DEFINITIONS_<CONFIG> is deprecated since CMake 3.0 in favor of generator expressions.
# These have existed since CMake 2.8.10; until we depend on that, we have to explicitly enable the old policy.
if (POLICY CMP0043)
    cmake_policy(SET CMP0043 OLD)
endif()

# Honor visibility settings for all target types
if (POLICY CMP0063)
    cmake_policy(SET CMP0063 NEW)
endif()

# Don't automoc generated files
if (POLICY CMP0071)
    cmake_policy(SET CMP0071 OLD)
endif()


# Simplify later checks
#####################################################################

if (WANT_MONO OR WANT_QTCLIENT)
    set(BUILD_GUI true)
endif()
if (WANT_MONO OR WANT_CORE)
    set(BUILD_CORE true)
endif()


# Set up Qt
#####################################################################

# Find package dependencies
#
# Note that you can forcefully disable optional packages
# using -DCMAKE_DISABLE_FIND_PACKAGE_<PkgName>=TRUE
#####################################################################

if (USE_QT5)
    message(STATUS "Building for Qt5...")
    set(QT_MIN_VERSION "5.2.0")
    add_definitions(-DHAVE_QT5)

    find_package(Qt5Core ${QT_MIN_VERSION} QUIET)
    set_package_properties(Qt5Core PROPERTIES TYPE REQUIRED
        URL "https://www.qt.io/"
        DESCRIPTION "contains core functionality for Qt"
    )
    # find_package without REQUIRED won't check for the version properly; also, older Qt5 versions
    # used Qt5Core_VERSION_STRING... let's just make sure here that we bail out here if our Qt5 is not new enough.
    if (NOT Qt5Core_VERSION OR Qt5Core_VERSION VERSION_LESS ${QT_MIN_VERSION})
        message(FATAL_ERROR "Could NOT find Qt5 >= version ${QT_MIN_VERSION}!")
    endif()

    find_package(Qt5Network QUIET)
    set_package_properties(Qt5Network PROPERTIES TYPE REQUIRED
        DESCRIPTION "the network module for Qt5"
    )

    if (BUILD_GUI)
        find_package(Qt5Gui QUIET)
        set_package_properties(Qt5Gui PROPERTIES TYPE REQUIRED
            DESCRIPTION "the GUI module for Qt5"
        )
        find_package(Qt5Widgets QUIET)
        set_package_properties(Qt5Widgets PROPERTIES TYPE REQUIRED
            DESCRIPTION "the widgets module for Qt5"
        )

        if (NOT WIN32)
            find_package(Qt5DBus QUIET)
            set_package_properties(Qt5DBus PROPERTIES TYPE RECOMMENDED
                URL "https://www.qt.io/"
                DESCRIPTION "D-Bus support for Qt5"
                PURPOSE     "Needed for supporting D-Bus-based notifications and tray icon, used by most modern desktop environments"
            )
            if (Qt5DBus_FOUND)
                find_package(dbusmenu-qt5 QUIET CONFIG)
                set_package_properties(dbusmenu-qt5 PROPERTIES TYPE RECOMMENDED
                    URL "https://launchpad.net/libdbusmenu-qt"
                    DESCRIPTION "a library implementing the DBusMenu specification"
                    PURPOSE     "Required for having a context menu for the D-Bus-based tray icon"
                )
            endif()
        endif()

        find_package(Qt5Multimedia QUIET)
        set_package_properties(Qt5Multimedia PROPERTIES TYPE RECOMMENDED
            URL "https://www.qt.io/"
            DESCRIPTION "Multimedia support for Qt5"
            PURPOSE     "Required for audio notifications"
        )

        if (NOT Qt5Multimedia_FOUND)
            find_package(Phonon4Qt5 QUIET)
            set_package_properties(Phonon4Qt5 PROPERTIES TYPE RECOMMENDED
                URL "https://projects.kde.org/projects/kdesupport/phonon"
                DESCRIPTION "a multimedia abstraction library"
                PURPOSE     "Required for audio notifications"
            )
        endif()

        find_package(LibsnoreQt5 0.7.0 QUIET)
        set_package_properties(LibsnoreQt5 PROPERTIES TYPE OPTIONAL
            URL "https://projects.kde.org/projects/playground/libs/snorenotify"
            DESCRIPTION "a cross-platform notification framework"
            PURPOSE     "Enable support for the snorenotify framework"
        )
        if(LibsnoreQt5_FOUND)
            find_package(LibsnoreSettingsQt5)
            set_package_properties(LibsnoreSettingsQt5 PROPERTIES TYPE REQUIRED
                URL "https://projects.kde.org/projects/playground/libs/snorenotify"
                DESCRIPTION "a cross-platform notification framework"
                PURPOSE     "Enable support for the snorenotify framework"
            )
        endif()


        if (WITH_WEBKIT)
            find_package(Qt5WebKit QUIET)
            set_package_properties(Qt5WebKit PROPERTIES TYPE RECOMMENDED
                URL "https://www.qt.io/"
                DESCRIPTION "a WebKit implementation for Qt"
                PURPOSE     "Needed for displaying previews for URLs in chat"
            )
            if (Qt5WebKit_FOUND)
                find_package(Qt5WebKitWidgets QUIET)
                set_package_properties(Qt5WebKitWidgets PROPERTIES TYPE RECOMMENDED
                    URL "https://www.qt.io/"
                    DESCRIPTION "widgets for Qt's WebKit implementation"

=== icons/CMakeLists.txt ===
# Install icons

if (WANT_MONO OR WANT_QTCLIENT)
    if (NOT WITH_BUNDLED_ICONS AND NOT WITH_OXYGEN_ICONS)
        message(WARNING "Not including bundled icon themes. Ensure that the Breeze or Oxygen icon theme is installed!")
    endif()

    set(BUNDLED_ICON_THEME_DIR ${CMAKE_SOURCE_DIR}/3rdparty/icons)

    # Always embed a hicolor fallback containing the most important (e.g. tray) icons
    list(APPEND ICON_RCS ${CMAKE_CURRENT_SOURCE_DIR}/hicolor_icons.qrc)

    if (EMBED_DATA)
        # Always embed quassel-specific icons
        message(STATUS "Embedding Quassel-specific icons")
        list(APPEND ICON_RCS ${CMAKE_CURRENT_SOURCE_DIR}/breeze_icons.qrc)
        list(APPEND ICON_RCS ${CMAKE_CURRENT_SOURCE_DIR}/breeze_dark_icons.qrc)
        if (WITH_OXYGEN_ICONS)
            list(APPEND ICON_RCS ${CMAKE_CURRENT_SOURCE_DIR}/oxygen_icons.qrc)
        endif()

        if (WITH_BUNDLED_ICONS)
            message(STATUS "Embedding bundled Breeze icon theme")
            list(APPEND ICON_RCS ${BUNDLED_ICON_THEME_DIR}/breeze_icon_theme.qrc)
            list(APPEND ICON_RCS ${BUNDLED_ICON_THEME_DIR}/breeze_dark_icon_theme.qrc)
            if (WITH_OXYGEN_ICONS)
                message(STATUS "Embedding bundled Oxygen icon theme")
                list(APPEND ICON_RCS ${BUNDLED_ICON_THEME_DIR}/oxygen_icon_theme.qrc)
            endif()
        endif()

    else()
        # Always install quassel-specific icons
        install(DIRECTORY breeze breeze-dark DESTINATION ${CMAKE_INSTALL_DATADIR}/quassel/icons)
        if (WITH_OXYGEN_ICONS)
            install(DIRECTORY oxygen DESTINATION ${CMAKE_INSTALL_DATADIR}/quassel/icons)
        endif()

        # Install bundled icon themes into our data dir (instead of CMAKE_INSTALL_ICONDIR) to avoid conflicts
        # with themes provided by the system
        if (WITH_BUNDLED_ICONS)
            message(STATUS "Installing bundled Breeze icon theme")
            install(DIRECTORY   ${BUNDLED_ICON_THEME_DIR}/breeze
                                ${BUNDLED_ICON_THEME_DIR}/breeze-dark
                    DESTINATION ${CMAKE_INSTALL_DATADIR}/quassel/icons
            )
            if (WITH_OXYGEN_ICONS)
                message(STATUS "Installing bundled Oxygen icon theme")
                install(DIRECTORY ${BUNDLED_ICON_THEME_DIR}/oxygen DESTINATION ${CMAKE_INSTALL_DATADIR}/quassel/icons)
            endif()
        endif()
    endif()

    set(CLIENT_RCS ${CLIENT_RCS} ${ICON_RCS} PARENT_SCOPE)

    # Application icon
    if (HAVE_KDE OR (UNIX AND NOT APPLE))
        # hicolor contains the application icon in all relevant sizes
        install(DIRECTORY hicolor DESTINATION ${CMAKE_INSTALL_ICONDIR})

        if (USE_QT4 OR (USE_QT5 AND Qt5Core_VERSION VERSION_LESS 5.5.0))
            # Qt 4 doesn't seem to correctly load icons from injected themes
            # Install Quassel-specific ones from Oxygen into hicolor as fallback
            install(DIRECTORY oxygen/ DESTINATION ${CMAKE_INSTALL_ICONDIR}/hicolor)
        endif()

        # For a system install, also copy to pixmaps
        if (CMAKE_INSTALL_PREFIX STREQUAL "/usr")
            install(FILES hicolor/48x48/apps/quassel.png DESTINATION /usr/share/pixmaps)
        endif()
    endif()
endif()

=== pics/CMakeLists.txt ===
# pics/ contains non-themed icons and other graphical resources

if(WIN32)
  if(MINGW)
    find_program(WINDRES_EXECUTABLE NAMES windres)
    if(WINDRES_EXECUTABLE)
      exec_program(windres
              ARGS "-i ${CMAKE_CURRENT_SOURCE_DIR}/win32.rc"
                   "-o ${CMAKE_CURRENT_BINARY_DIR}/win32.o"
                   "--include-dir=${CMAKE_CURRENT_SOURCE_DIR}")
      set(COMMON_DEPS ${COMMON_DEPS} ${CMAKE_CURRENT_BINARY_DIR}/win32.o PARENT_SCOPE)
    endif()
  else()
    set(COMMON_DEPS ${COMMON_DEPS} ${CMAKE_CURRENT_SOURCE_DIR}/win32.rc PARENT_SCOPE)
  endif()
endif()

if(WANT_MONO OR WANT_QTCLIENT)
  if(EMBED_DATA)
    set(CLIENT_RCS ${CLIENT_RCS} ${CMAKE_CURRENT_SOURCE_DIR}/pics.qrc PARENT_SCOPE)
  else()
    # We don't find them yet externally, so disable installation
    set(CLIENT_RCS ${CLIENT_RCS} ${CMAKE_CURRENT_SOURCE_DIR}/pics.qrc PARENT_SCOPE)
    # install(FILES quassel-large.png
    #         DESTINATION ${DATA_INSTALL_DIR}/quassel/pics)
  endif()
endif()

=== po/CMakeLists.txt ===
# Generate and add translations
# The LINGUAS variable can be used to limit that set

if(QT_LCONVERT_EXECUTABLE)
  # get environment variable for translations
  set(LINGUAS "$ENV{LINGUAS}")
  string(REGEX REPLACE "[ \t]+" \; output "${LINGUAS}")
  # Find more languages
  # We support xx.po and xx_YY.po, and additionally translations for qt using qt_xx.po or qt_xx_YY.po
  file(GLOB avail_pofiles *.po)
  foreach(PO_FILE ${avail_pofiles})
    get_filename_component(basename ${PO_FILE} NAME_WE)
    # CMake can't use MATCH to get the second catch...
    string(REGEX REPLACE "(qt_)?([a-zA-Z]+)(_.+)?$" "\\2" lang ${basename})

    # test if we want this language
    set(flg 1)
    if(LINGUAS)
      string(REGEX MATCH "${lang}" flg ${LINGUAS})
    endif()
    if(flg)
      generate_ts(QM ${basename})
      generate_qm(QM ${basename})
      list(APPEND qm_files ${QM})
      list(APPEND gen_linguas ${lang})
    endif()
  endforeach(PO_FILE ${avail_pofiles})
  if(gen_linguas)
    list(REMOVE_DUPLICATES gen_linguas)
  endif()
  message(STATUS "Including languages: ${gen_linguas}")
else()
  message(STATUS "WARNING: lconvert not found, you won't have translations!")
endif()

# For a static or win32 build, we need to include Qt translations if available
if(QT_TRANSLATIONS_DIR)
  if(STATIC OR WIN32)
    foreach(LANG ${gen_linguas})
      file(GLOB lang_files ${QT_TRANSLATIONS_DIR}/qt_${LANG}*.qm)
      foreach(absfile ${lang_files})
        get_filename_component(filename ${absfile} NAME)
        message(STATUS "Importing ${filename}")
        configure_file(${absfile} ${CMAKE_CURRENT_BINARY_DIR}/${filename} COPYONLY)
        list(APPEND qm_files ${CMAKE_CURRENT_BINARY_DIR}/${filename})
      endforeach(absfile ${lang_files})
    endforeach(LANG ${gen_linguas})
  endif()
endif()

# Write resource file
set(resfile ${CMAKE_CURRENT_BINARY_DIR}/i18n.qrc)
file(WRITE ${resfile} "<!DOCTYPE RCC><RCC version=\"1.0\">\n"
                      "<qresource prefix=\"/i18n\">\n")
foreach(file ${qm_files})
  get_filename_component(file ${file} NAME)
  file(APPEND ${resfile} "    <file>${file}</file>\n")
endforeach(file ${qm_files})
file(APPEND ${resfile} "</qresource>\n</RCC>\n")

#add_custom_command(OUTPUT ${resfile} DEPENDS ${qm_files})
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${qm_files};i18n.qrc")

if(EMBED_DATA)
  set(COMMON_RCS ${COMMON_RCS} ${resfile} PARENT_SCOPE)
else()
  install(FILES ${qm_files} DESTINATION ${CMAKE_INSTALL_DATADIR}/quassel/translations)
endif()

add_custom_target(po DEPENDS ${qm_files})

=== src/CMakeLists.txt ===
# Builds the three main targets

add_subdirectory(common)
include_directories(BEFORE common)
if(BUILD_CORE)
  add_subdirectory(core)
  include_directories(BEFORE core)
endif()
if(BUILD_GUI)
  add_subdirectory(client)
  add_subdirectory(uisupport)
  add_subdirectory(qtui)
  include_directories(BEFORE client)
  include_directories(BEFORE uisupport)
  include_directories(BEFORE qtui)

  if(STATIC)
    link_directories(${QT_PLUGINS_DIR}/imageformats)
    set(CLIENT_LIBRARIES ${CLIENT_LIBRARIES} qjpeg qgif)
  endif()
endif()

include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR}) # for version.gen

# We need to initialize the appropriate resources, so let's give our main.cpp some hints
if (EMBED_DATA)
    add_definitions(-DEMBED_DATA)
endif()

# For KAboutData
if (WITH_KF5)
    set(CLIENT_LIBRARIES ${CLIENT_LIBRARIES} KF5::CoreAddons)
endif()

# Needed for showing the cli option if appropriate
if (HAVE_SYSLOG)
    add_definitions(-DHAVE_SYSLOG)
endif()

if(WANT_CORE)
  add_executable(quasselcore common/main.cpp ${CORE_DEPS} ${COMMON_DEPS})
  qt_use_modules(quasselcore Core Network ${CORE_QT_MODULES})
  add_dependencies(quasselcore po)
  set_target_properties(quasselcore PROPERTIES
                                    COMPILE_FLAGS "-DBUILD_CORE"
                                    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
  target_link_libraries(quasselcore mod_core mod_common ${COMMON_LIBRARIES} ${QUASSEL_SSL_LIBRARIES} ${QT_QTMAIN_LIBRARY})
  install(TARGETS quasselcore RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

if (KDE4_FOUND)
    include_directories(${KDE4_INCLUDES})
endif()

if(WANT_QTCLIENT)
  add_executable(quasselclient WIN32 common/main.cpp ${CLIENT_DEPS} ${COMMON_DEPS})
  qt_use_modules(quasselclient Core Gui Network ${CLIENT_QT_MODULES})
  add_dependencies(quasselclient po)
  set_target_properties(quasselclient PROPERTIES
                                      COMPILE_FLAGS "-DBUILD_QTUI"
                                      RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
  target_link_libraries(quasselclient mod_qtui mod_uisupport mod_client mod_common ${COMMON_LIBRARIES} ${CLIENT_LIBRARIES} ${QUASSEL_SSL_LIBRARIES} ${QT_QTMAIN_LIBRARY})
  install(TARGETS quasselclient RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

if(WANT_MONO)
  add_executable(quassel WIN32 common/main.cpp qtui/monoapplication.cpp ${CLIENT_DEPS} ${CORE_DEPS} ${COMMON_DEPS})
  qt_use_modules(quassel Core Gui Network ${CLIENT_QT_MODULES} ${CORE_QT_MODULES})
  add_dependencies(quassel po)
  set_target_properties(quassel PROPERTIES
                                COMPILE_FLAGS "-DBUILD_MONO"
                                RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
  target_link_libraries(quassel mod_qtui mod_uisupport mod_client mod_core mod_common ${COMMON_LIBRARIES} ${CLIENT_LIBRARIES} ${QUASSEL_SSL_LIBRARIES} ${QT_QTMAIN_LIBRARY})
  install(TARGETS quassel RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

# Build bundles for MacOSX
if(APPLE)
  add_custom_command(TARGET quasselclient POST_BUILD
                     COMMAND ${CMAKE_SOURCE_DIR}/scripts/build/macosx_makebundle.py
                             ${CMAKE_SOURCE_DIR} "Quassel Client" ../quasselclient)
  add_custom_command(TARGET quassel POST_BUILD
                     COMMAND ${CMAKE_SOURCE_DIR}/scripts/build/macosx_makebundle.py
                             ${CMAKE_SOURCE_DIR} "Quassel" ../quassel)
  if(DEPLOY)
    add_custom_command(TARGET quasselclient POST_BUILD
                       COMMAND ${CMAKE_SOURCE_DIR}/scripts/build/macosx_makePackage.sh Client .. qsvgicon)
    add_custom_command(TARGET quasselcore POST_BUILD
                       COMMAND ${CMAKE_SOURCE_DIR}/scripts/build/macosx_makePackage.sh Core ..)
    add_custom_command(TARGET quassel POST_BUILD
                       COMMAND ${CMAKE_SOURCE_DIR}/scripts/build/macosx_makePackage.sh Mono .. qsvgicon)
  endif()
endif()

=== src/client/CMakeLists.txt ===
# Builds the client module

# In Qt4, we still have some minor deps to QtGui: QItemSelectionModel, QSortFilterProxyModel
# Still in Qt5: QAbstractItemView in BufferModel

set(SOURCES
    abstractmessageprocessor.cpp
    backlogrequester.cpp
    buffermodel.cpp
    buffersettings.cpp
    bufferviewoverlay.cpp
    client.cpp
    clientaliasmanager.cpp
    clientauthhandler.cpp
    clientbacklogmanager.cpp
    clientbufferviewconfig.cpp
    clientbufferviewmanager.cpp
    clientidentity.cpp
    clientignorelistmanager.cpp
    clientirclisthelper.cpp
    clientsettings.cpp
    clienttransfer.cpp
    clienttransfermanager.cpp
    clientuserinputhandler.cpp
    coreaccount.cpp
    coreaccountmodel.cpp
    coreconnection.cpp
    execwrapper.cpp
    irclistmodel.cpp
    messagefilter.cpp
    messagemodel.cpp
    networkmodel.cpp
    selectionmodelsynchronizer.cpp
    transfermodel.cpp
    treemodel.cpp

    # needed for automoc
    abstractui.h
)

if (USE_QT5)
    list(APPEND qt_modules Widgets)
endif()

qt_add_resources(SOURCES ${CLIENT_RCS})

add_library(mod_client STATIC ${SOURCES})
qt_use_modules(mod_client Network Core Gui ${qt_modules})

target_link_libraries(mod_client mod_common)

=== src/common/CMakeLists.txt ===
# Builds the common module

set(SOURCES
    abstractsignalwatcher.h
    aliasmanager.cpp
    authhandler.cpp
    backlogmanager.cpp
    basichandler.cpp
    bufferinfo.cpp
    buffersyncer.cpp
    bufferviewconfig.cpp
    bufferviewmanager.cpp
    compressor.cpp
    coreinfo.cpp
    ctcpevent.cpp
    dccconfig.cpp
    event.cpp
    eventmanager.cpp
    expressionmatch.cpp
    # expressionmatchtests.cpp
    highlightrulemanager.cpp
    identity.cpp
    ignorelistmanager.cpp
    internalpeer.cpp
    ircchannel.cpp
    ircevent.cpp
    irclisthelper.cpp
    ircuser.cpp
    logger.cpp
    logmessage.cpp
    message.cpp
    messageevent.cpp
    network.cpp
    networkconfig.cpp
    networkevent.cpp
    nickhighlightmatcher.cpp
    peer.cpp
    peerfactory.cpp
    presetnetworks.cpp
    quassel.cpp
    remotepeer.cpp
    settings.cpp
    signalproxy.cpp
    singleton.h
    syncableobject.cpp
    transfer.cpp
    transfermanager.cpp
    types.cpp
    util.cpp

    serializers/serializers.cpp

    protocols/datastream/datastreampeer.cpp
    protocols/legacy/legacypeer.cpp

    # needed for automoc
    irccap.h
    protocol.h
)

if (USE_QT5)
    list(APPEND SOURCES qt5cliparser.cpp)
else()
    list(APPEND SOURCES cliparser.cpp)
endif()

if (QCA2_FOUND OR QCA2-QT5_FOUND)
    set(SOURCES ${SOURCES} keyevent.cpp)
endif()

if (ZLIB_FOUND)
    add_definitions(-DHAVE_ZLIB)
    include_directories(${ZLIB_INCLUDE_DIRS})
else()
    set(SOURCES ${SOURCES} ../../3rdparty/miniz/miniz.c)
endif()

if (USE_QT4)
    set(SOURCES ${SOURCES} ../../3rdparty/sha512/sha512.c)
endif()

if (HAVE_SYSLOG)
    add_definitions(-DHAVE_SYSLOG)
endif()

if (APPLE)
    set(SOURCES ${SOURCES} mac_utils.cpp)
endif()

if (WIN32)
    set(SOURCES ${SOURCES} logbacktrace_win.cpp windowssignalwatcher.cpp)
else()
    if (EXECINFO_FOUND)
        add_definitions(-DHAVE_EXECINFO)
        include_directories(${EXECINFO_INCLUDES})
    endif()
    set(SOURCES ${SOURCES} logbacktrace_unix.cpp posixsignalwatcher.cpp)
endif()

qt_add_resources(SOURCES ${COMMON_RCS})

add_library(mod_common STATIC ${SOURCES})
qt_use_modules(mod_common Core Network)

if (APPLE)
    target_link_libraries(mod_common "-framework CoreServices" "-framework CoreFoundation")
endif()

target_link_libraries(mod_common ${CMAKE_DL_LIBS} ${EXECINFO_LIBRARIES})

if(ZLIB_FOUND)
    target_link_libraries(mod_common ${ZLIB_LIBRARIES})
endif()

# This is needed so translations are generated before trying to build the qrc.
# Should probably find a nicer solution with proper dependencies between the involved files, though...
add_dependencies(mod_common po)

=== src/core/CMakeLists.txt ===
# Builds the core module

set(SOURCES
    abstractsqlstorage.cpp
    authenticator.cpp
    core.cpp
    corealiasmanager.cpp
    coreapplication.cpp
    coreauthhandler.cpp
    corebacklogmanager.cpp
    corebasichandler.cpp
    corebuffersyncer.cpp
    corebufferviewconfig.cpp
    corebufferviewmanager.cpp
    coredccconfig.cpp
    corehighlightrulemanager.cpp
    coreidentity.cpp
    coreignorelistmanager.cpp
    coreircchannel.cpp
    coreirclisthelper.cpp
    coreircuser.cpp
    corenetwork.cpp
    corenetworkconfig.cpp
    coresession.cpp
    coresessioneventprocessor.cpp
    coresettings.cpp
    coretransfer.cpp
    coretransfermanager.cpp
    coreuserinputhandler.cpp
    coreusersettings.cpp
    ctcpparser.cpp
    eventstringifier.cpp
    identserver.cpp
    ircparser.cpp
    netsplit.cpp
    oidentdconfiggenerator.cpp
    postgresqlstorage.cpp
    sessionthread.cpp
    sqlauthenticator.cpp
    sqlitestorage.cpp
    storage.cpp

    # needed for automoc
    coreeventmanager.h
)

set(LIBS )

if(HAVE_SSL)
  set(SOURCES ${SOURCES} sslserver.cpp)
  include_directories(${OPENSSL_INCLUDE_DIR})
endif()

if (QCA2_FOUND)
    add_definitions(-DHAVE_QCA2)
    include_directories(${QCA2_INCLUDE_DIR})
    list(APPEND SOURCES cipher.cpp)
    list(APPEND LIBS ${QCA2_LIBRARIES})
endif()

if (QCA2-QT5_FOUND)
    add_definitions(-DHAVE_QCA2)
    include_directories(${QCA2-QT5_INCLUDE_DIR})
    list(APPEND SOURCES cipher.cpp)
    list(APPEND LIBS ${QCA2-QT5_LIBRARIES})
endif()

# Build with LDAP if told to do so.
if(HAVE_LDAP)
    include_directories(${LDAP_INCLUDE_DIR})
    set(SOURCES ${SOURCES} ldapauthenticator.cpp)
    set(MOC_HDRS ${MOC_HDRS} ldapauthenticator.h)
endif(HAVE_LDAP)

include_directories(${CMAKE_SOURCE_DIR}/src/common)

set(CORE_RCS ${CORE_RCS} ${CMAKE_CURRENT_SOURCE_DIR}/sql.qrc)
qt_add_resources(SOURCES ${CORE_RCS})

add_library(mod_core STATIC ${SOURCES})
qt_use_modules(mod_core Core Network Script Sql)

target_link_libraries(mod_core mod_common ${LIBS})

if(HAVE_LDAP)
    target_link_libraries(mod_core ${LDAP_LIBRARIES})
endif(HAVE_LDAP)

=== src/qtui/CMakeLists.txt ===
# Builds the qtui module

set(SOURCES
    aboutdlg.cpp
    awaylogfilter.cpp
    awaylogview.cpp
    bufferwidget.cpp
    channellistdlg.cpp
    chatitem.cpp
    chatline.cpp
    chatlinemodel.cpp
    chatlinemodelitem.cpp
    chatmonitorfilter.cpp
    chatmonitorview.cpp
    chatscene.cpp
    chatview.cpp
    chatviewsearchbar.cpp
    chatviewsearchcontroller.cpp
    chatviewsettings.cpp
    columnhandleitem.cpp
    coreconfigwizard.cpp
    coreconnectdlg.cpp
    coreconnectionstatuswidget.cpp
    coreinfodlg.cpp
    coresessionwidget.cpp
    debugbufferviewoverlay.cpp
    debugconsole.cpp
    debuglogdlg.cpp
    debugmessagemodelfilter.cpp
    inputwidget.cpp
    ircconnectionwizard.cpp
    legacysystemtray.cpp
    mainpage.cpp
    mainwin.cpp
    markerlineitem.cpp
    msgprocessorstatuswidget.cpp
    nicklistwidget.cpp
    passwordchangedlg.cpp
    qtui.cpp
    qtuiapplication.cpp
    qtuimessageprocessor.cpp
    qtuisettings.cpp
    qtuistyle.cpp
    receivefiledlg.cpp
    settingsdlg.cpp
    settingspagedlg.cpp
    simplenetworkeditor.cpp
    systemtray.cpp
    systrayanimationnotificationbackend.cpp
    systraynotificationbackend.cpp
    taskbarnotificationbackend.cpp
    titlesetter.cpp
    topicwidget.cpp
    verticaldock.cpp
    webpreviewitem.cpp
)

set(FORMS
    aboutdlg.ui
    bufferviewwidget.ui
    bufferwidget.ui
    channellistdlg.ui
    chatviewsearchbar.ui
    coreconfigwizardintropage.ui
    coreconfigwizardauthenticationselectionpage.ui
    coreconfigwizardadminuserpage.ui
    coreconfigwizardstorageselectionpage.ui
    coreconfigwizardsyncpage.ui
    coreconnectauthdlg.ui
    coreconnectionstatuswidget.ui
    coreinfodlg.ui
    coresessionwidget.ui
    debugbufferviewoverlay.ui
    debugconsole.ui
    debuglogdlg.ui
    inputwidget.ui
    msgprocessorstatuswidget.ui
    nicklistwidget.ui
    passwordchangedlg.ui
    receivefiledlg.ui
    settingsdlg.ui
    settingspagedlg.ui
    simplenetworkeditor.ui
    systrayanimationconfigwidget.ui
    topicwidget.ui
)

set(LIBS )
set(QT_MODULES )

if (WITH_KDE4)
    add_definitions(-DHAVE_KDE ${KDE4_DEFINITIONS})
    include_directories(${KDE4_INCLUDES})
    list(APPEND SOURCES knotificationbackend.cpp)
    list(APPEND LIBS ${KDE4_KDECORE_LIBS} ${KDE4_KDEUI_LIBRARY} ${KDE4_KNOTIFYCONFIG_LIBRARY})
endif()

if (WITH_KF5)
    list(APPEND SOURCES knotificationbackend.cpp)
    list(APPEND LIBS KF5::ConfigWidgets KF5::Notifications KF5::NotifyConfig KF5::WidgetsAddons KF5::XmlGui)
endif()

if (LibsnoreQt5_FOUND)
    add_definitions(-DHAVE_LIBSNORE)
    list(APPEND SOURCES snorenotificationbackend.cpp)
    list(APPEND FORMS   snorentificationconfigwidget.ui)
    list(APPEND LIBS    Snore::Libsnore Snore::LibsnoreSettings)
endif()

if (Qt5Multimedia_FOUND)
    add_definitions(-DHAVE_QTMULTIMEDIA)
    list(APPEND QT_MODULES Multimedia)
    set(SOURCES ${SOURCES} qtmultimedianotificationbackend.cpp)
    set(FORMS ${FORMS}     qtmultimedianotificationconfigwidget.ui)
endif()

if (PHONON_FOUND OR Phonon4Qt5_FOUND)
    add_definitions(-DHAVE_PHONON)
    include_directories(${PHONON_INCLUDES})
    set(SOURCES ${SOURCES} phononnotificationbackend.cpp)
    set(FORMS ${FORMS}     phononnotificationconfigwidget.ui)
    list(APPEND LIBS ${PHONON_LIBS})  # PHONON_LIBRARIES only exists in config mode, it's not set by the legacy FindPhonon.cmake
endif()

if (QT_QTDBUS_FOUND OR Qt5DBus_FOUND)
    add_definitions(-DHAVE_DBUS)
    list(APPEND QT_MODULES DBus)
    if (dbusmenu-qt_FOUND OR dbusmenu-qt5_FOUND)
        add_definitions(-DHAVE_DBUSMENU)
        include_directories(${dbusmenu-qt_INCLUDE_DIRS} ${dbusmenu-qt5_INCLUDE_DIRS})
        if (dbusmenu-qt_FOUND)
            list(APPEND LIBS dbusmenu-qt)
        else()
            list(APPEND LIBS dbusmenu-qt5)
        endif()
    endif()

    list(APPEND SOURCES statusnotifieritem.cpp statusnotifieritemdbus.cpp dockmanagernotificationbackend.cpp)
    qt_add_dbus_interface(SOURCES ../../interfaces/org.kde.StatusNotifierWatcher.xml statusnotifierwatcher)
    qt_add_dbus_interface(SOURCES ../../interfaces/org.freedesktop.Notifications.xml notificationsclient)
    qt_add_dbus_adaptor  (SOURCES ../../interfaces/org.kde.StatusNotifierItem.xml statusnotifieritemdbus.h StatusNotifierItemDBus)
endif()

if (HAVE_WEBKIT)
    add_definitions(-DHAVE_WEBKIT)
    list(APPEND QT_MODULES WebKit)
    if (USE_QT5)
        list(APPEND QT_MODULES WebKitWidgets)
    endif()
endif()

if (HAVE_WEBENGINE)
    add_definitions(-DHAVE_WEBENGINE)
    list(APPEND QT_MODULES WebEngine)
    if (USE_QT5)
        list(APPEND QT_MODULES WebEngineWidgets)
    endif()
endif()

if(HAVE_SSL)
  set(SOURCES ${SOURCES} sslinfodlg.cpp)
  set(FORMS ${FORMS} sslinfodlg.ui)
endif()

if (INDICATEQT_FOUND)
    add_definitions(-DHAVE_INDICATEQT)
    include_directories(${INDICATEQT_INCLUDE_DIRS})
    list(APPEND SOURCES indicatornotificationbackend.cpp)
    list(APPEND FORMS   indicatornotificationconfigwidget.ui)
    list(APPEND LIBS ${INDICATEQT_LIBRARIES})
endif()

if (WITH_NOTIFICATION_CENTER)
    add_definitions(-DHAVE_NOTIFICATION_CENTER)
    list(APPEND SOURCES osxnotificationbackend.mm)
    list(APPEND LIBS "/System/Library/Frameworks/Foundation.framework")
endif()

if (KF5Sonnet_FOUND)
    add_definitions(-DHAVE_SONNET)
    list(APPEND SOURCES settingspages/sonnetsettingspage.cpp)
    list(APPEND LIBS KF5::SonnetUi)
endif()

foreach(FORM ${FORMS})
  set(FORMPATH ${FORMPATH} ui/${FORM})
endforeach(FORM ${FORMS})

# handle settingspages
include(settingspages/settingspages.cmake)
foreach(SP ${SETTINGSPAGES})
  set(SPSRC ${SPSRC} settingspages/${SP}settingspage.cpp)
  set(SPFRM ${SPFRM} settingspages/${SP}settingspage.ui)
endforeach(SP ${SETTINGSPAGES})
foreach(SRC ${SP_SOURCES})
  set(SPSRC ${SPSRC} settingspages/${SRC})
endforeach(SRC ${SP_SOURCES})
foreach(FRM ${SP_FORMS})
  set(SPFRM ${SPFRM} settingspages/${FRM})
endforeach(FRM ${SP_FORMS})

include_directories(${CMAKE_SOURCE_DIR}/src/common
                    ${CMAKE_SOURCE_DIR}/src/client
                    ${CMAKE_SOURCE_DIR}/src/qtui
                    ${CMAKE_SOURCE_DIR}/src/qtui/settingspages
                    ${CMAKE_SOURCE_DIR}/src/uisupport
)

qt_wrap_ui(UI ${FORMPATH} ${SPFRM})

if (USE_QT5)
    list(APPEND QT_MODULES Widgets)
endif()


add_library(mod_qtui STATIC ${SOURCES} ${SPSRC} ${UI})
qt_use_modules(mod_qtui Core Gui Network ${QT_MODULES})

target_link_libraries(mod_qtui mod_client mod_common mod_uisupport ${LIBS})

=== src/uisupport/CMakeLists.txt ===
# Builds the uisupport module

set(SOURCES
    aboutdata.cpp
    abstractbuffercontainer.cpp
    abstractitemview.cpp
    action.cpp
    actioncollection.cpp
    bufferhotlistfilter.cpp
    bufferview.cpp
    bufferviewfilter.cpp
    bufferviewoverlayfilter.cpp
    clearablelineedit.cpp
    clickable.cpp
    clickablelabel.cpp
    colorbutton.cpp
    contextmenuactionprovider.cpp
    flatproxymodel.cpp
    fontselector.cpp
    graphicalui.cpp
    icon.cpp
    multilineedit.cpp
    networkmodelcontroller.cpp
    nickview.cpp
    nickviewfilter.cpp
    qssparser.cpp
    resizingstackedwidget.cpp
    settingspage.cpp
    styledlabel.cpp
    tabcompleter.cpp
    toolbaractionprovider.cpp
    treeviewtouch.cpp
    uisettings.cpp
    uistyle.cpp

    # needed for automoc
    abstractnotificationbackend.h
)

if (WITH_KDE4)
    include_directories(${KDE4_INCLUDES})
    add_definitions(-DHAVE_KDE ${KDE4_DEFINITIONS})
    set(SOURCES ${SOURCES} kcmdlinewrapper.cpp)
endif()

include_directories(${CMAKE_SOURCE_DIR}/src/common
                    ${CMAKE_SOURCE_DIR}/src/client
)

if (USE_QT5)
    list(APPEND qt_modules Widgets)
endif()

add_library(mod_uisupport STATIC ${SOURCES})
qt_use_modules(mod_uisupport Core Gui Network ${qt_modules})

target_link_libraries(mod_uisupport mod_client mod_common)

if (WITH_KDE4)
    target_link_libraries(mod_uisupport ${KDE4_KDECORE_LIBS} ${KDE4_KDEUI_LIBRARY})
endif()

if (WITH_KF5)
    target_link_libraries(mod_uisupport KF5::CoreAddons KF5::TextWidgets KF5::XmlGui)
endif()

if (KF5Sonnet_FOUND)
    add_definitions(-DHAVE_SONNET)
    target_link_libraries(mod_uisupport KF5::SonnetUi)
endif()

=== debian/changelog ===
quassel (1:0.13.1-5) unstable; urgency=medium

  [ Christian Göttsche ]
  * Start quasselcore with --require-ssl (Closes: #950244)

  [ Felix Geyer ]
  * Switch to debhelper compat level 12.

 -- Felix Geyer <fgeyer@debian.org>  Fri, 12 Feb 2021 18:40:17 +0100

quassel (1:0.13.1-4) unstable; urgency=medium

  [ Scott Kitterman ]
  * Add explicit build-depeds on debhelper (>= 10.3~) since we use dh_missing
  * Bump standards-version to 4.5.0 without further change
  * Add Recommends: ca-certificates to quassel and quassel-client so network
    certificates can be verified

  [ Felix Geyer ]
  * Add patches to fix building against Qt 5.14 from Ubuntu.
    Thanks Dan Streetman! (Closes: #964687)

 -- Felix Geyer <fgeyer@debian.org>  Mon, 13 Jul 2020 23:13:31 +0200

quassel (1:0.13.1-3) unstable; urgency=medium

  * Delete quassel-core.NEWS, not needed
  * Bump standards version to 4.4.1 without further change
  * Switch from deboan/compat + debhelper to debhelper-compat

 -- Scott Kitterman <scott@kitterman.com>  Sat, 18 Jan 2020 15:55:00 -0500

quassel (1:0.13.1-2) unstable; urgency=medium

  [ Felix Geyer ]
  * Fix quasselcore AppArmor denials when the config is saved. (Closes:
    #940482)

  [ Scott Kitterman ]
  * Correct default channel for Debian
  * Add NEWS entry about reloading the quaseelcore AppArmor profile

 -- Scott Kitterman <scott@kitterman.com>  Sat, 11 Jan 2020 15:00:28 -0500

quassel (1:0.13.1-1) unstable; urgency=medium

  [ Scott Kitterman ]
  * New upstream bugfix release
  * Do not explicitly set DEMBED_DATA=OFF, it is the default when KDE (Kf5)
    integration is enabled
  * Update debian/copyright
  * Add hurd-i386 to libqt5webkit5-dev build-depends arch list, since it is
    available there

  [ Shane Synan ]
  * Clean up and update manpages with new options for Quassel 0.13.1

 -- Scott Kitterman <scott@kitterman.com>  Fri, 15 Feb 2019 13:00:08 -0500

quassel (1:0.13.0-4) unstable; urgency=medium

  * Fix install of ufw profile so install is only attempted for quassel-core
    (fixes arch all FTBFS)
  * Replace obsolete dh_install --fail-missing with dh_missing --fail-missing

 -- Scott Kitterman <scott@kitterman.com>  Sun, 06 Jan 2019 04:33:59 -0500

quassel (1:0.13.0-3) unstable; urgency=medium

  [ Scott Kitterman ]
  * Make quassel-data Multi-Arch: foreign
  * Add apparmor profile (adopted from Ubuntu)
  * Bump standards-version to 4.3.0 without further change

  [ Michael Marley ]
  * Add reload support to quasselcore service to re-read SSL certificates
  * Add ufw profile (adopted from Ubuntu)

  [ Shane Synan ]
  * Clean up and update manpages with new options for Quassel 0.13.0
  * Update manpages to mention file paths for quassel, quasselclient, and
    quasselcore (Closes: #724617)

 -- Scott Kitterman <scott@kitterman.com>  Sat, 05 Jan 2019 23:45:11 -0500

=== debian/control ===
Source: quassel
Section: net
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Thomas Mueller <thomas.mueller@tmit.eu>,
           Felix Geyer <fgeyer@debian.org>,
           Scott Kitterman <scott@kitterman.com>
Build-Depends: debhelper-compat (= 12),
               dh-apparmor,
               cmake,
               libqca-qt5-2-dev,
               zlib1g-dev,
               qttools5-dev-tools,
               qttools5-dev,
               qtscript5-dev,
               qtmultimedia5-dev,
               libphonon4qt5-dev,
               libphonon4qt5experimental-dev,
               libdbusmenu-qt5-dev,
               qtwebengine5-dev [amd64 arm64 armhf i386 mipsel],
               libqt5webkit5-dev [armel hurd-i386 mips mips64el ppc64el s390x],
               extra-cmake-modules,
               libkf5textwidgets-dev,
               libkf5coreaddons-dev,
               libkf5xmlgui-dev,
               libkf5notifications-dev,
               libkf5notifyconfig-dev,
               libkf5widgetsaddons-dev,
               libssl-dev
Homepage: https://www.quassel-irc.org/
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/quassel.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/quassel

Package: quassel-core
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, libqt5sql5-sqlite, lsb-base (>= 3.2-14), openssl
Recommends: ca-certificates
Suggests: libqt5sql5-psql
Description: distributed IRC client - core component
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides only the core component.

Package: quassel-client
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, quassel-data (= ${source:Version}), default-dbus-session-bus | dbus-session-bus
Breaks: quassel-client-kde4 (<< 0.12.2)
Replaces: quassel-client-kde4 (<< 0.12.2)
Description: distributed IRC client - client component
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides only the client component.

Package: quassel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt5sql5-sqlite, quassel-data (= ${source:Version}), default-dbus-session-bus | dbus-session-bus
Recommends: ca-certificates
Breaks: quassel-kde4 (<< 0.12.2)
Replaces: quassel-kde4 (<< 0.12.2)
Description: distributed IRC client - monolithic core+client
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides the monolithic client. It contains both core and
 client and can be used like a traditional IRC client, without requiring an
 external core.

Package: quassel-data
Architecture: all
Depends: ${misc:Depends}
Recommends: breeze-icon-theme | oxygen-icon-theme
Suggests: inxi
Conflicts: quassel-data-kde4
Multi-Arch: foreign
Description: distributed IRC client - shared data
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides files used by the Quassel client packages.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed

WEBENGINE_INSTALL_STATUS := $(shell dpkg-query -W --showformat='$${Status}\n' qtwebengine5-dev|grep "install ok installed")
ifeq (install ok installed,$(WEBENGINE_INSTALL_STATUS))
	WEB_BACKEND = -DWITH_WEBKIT=OFF -DWITH_WEBENGINE=ON
else
	WEB_BACKEND = -DWITH_WEBKIT=ON -DWITH_WEBENGINE=OFF
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DWITH_OXYGEN_ICONS=ON -DWITH_BUNDLED_ICONS=OFF -DUSE_QT5=ON -DWITH_KDE=ON $(WEB_BACKEND)

override_dh_install:
	dh_install
	# replace inxi with a symlink
ifneq (,$(filter quassel-data, $(shell dh_listpackages)))
	rm debian/quassel-data/usr/share/quassel/scripts/inxi
endif

	dh_apparmor -pquassel-core --profile-name=usr.bin.quasselcore

override_dh_missing:
	dh_missing --fail-missing

override_dh_installinit:
	dh_installinit --no-stop-on-upgrade --no-restart-after-upgrade --error-handler=exit --name=quasselcore

override_dh_installsystemd:
	dh_installsystemd --no-stop-on-upgrade --no-restart-after-upgrade --name=quasselcore

## quassel 0.13.1-3ubuntu2.1%2B10.0trisquel2

=== debian/changelog ===
quassel (1:0.13.1-3ubuntu2.1+10.0trisquel2) nabia; urgency=medium

  * Change default channel

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Tue, 21 Sep 2021 15:55:16 +0000

quassel (1:0.13.1-3ubuntu2.1) focal; urgency=medium

  * d/usr.bin.quasselcore:
    - Update apparmor profile to allow running in lxd (LP: #1814302)

 -- Dan Streetman <ddstreet@canonical.com>  Sun, 28 Jun 2020 11:01:19 -0400

quassel (1:0.13.1-3ubuntu2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 25 Mar 2020 18:57:55 +0100

quassel (1:0.13.1-3ubuntu1) focal; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Change the default channel to #lubuntu.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 20 Jan 2020 09:36:26 +0100

quassel (1:0.13.1-2ubuntu1) focal; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Change the default channel to #lubuntu.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 13 Jan 2020 09:29:40 +0100

quassel (1:0.13.1-1ubuntu1) disco; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Dropping of (different) transitional packages since 16.04 LTS released.
    - Change the default channel to #lubuntu.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 16 Feb 2019 23:56:44 +0100

quassel (1:0.13.0-4ubuntu1) disco; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Dropping of (different) transitional packages since 16.04 LTS released.
    - Change the default channel to #lubuntu.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 07 Jan 2019 11:27:36 +0100

quassel (1:0.13.0-2ubuntu1) disco; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Dropping of (different) transitional packages since 16.04 LTS released.
    - Apparmor profile.
    - Ufw profile.
    - Change the default channel to #lubuntu.

 -- Rik Mills <rikmills@kubuntu.org>  Thu, 06 Dec 2018 05:46:52 +0000

## quassel 0.13.1.1+rb2

=== debian/changelog ===
quassel (1:0.13.1.1+rb2-1+eagle) unstable; urgency=medium

  * update

 -- Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>  Mon, 01 Feb 2021 16:22:48 +0800

quassel (1:0.13.1-1+deb10u2) buster; urgency=medium

  * Actually delete quassel-core.NEWS as intended
  * Add patches to fix building against Qt 5.14

 -- Scott Kitterman <scott@kitterman.com>  Sat, 18 Jan 2020 15:47:27 -0500

quassel (1:0.13.1-1+deb10u1) buster; urgency=medium

  [ Felix Geyer ]
  * Fix quasselcore AppArmor denials when the config is saved. (Closes:
    #940482)

  [ Scott Kitterman ]
  * Correct default channel for Debian

 -- Scott Kitterman <scott@kitterman.com>  Thu, 16 Jan 2020 23:28:02 -0500
